using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:submit_task_handle_info
    /// </summary>
    public partial class submit_task_handle_info
    {
        public submit_task_handle_info()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "submit_task_handle_info");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from submit_task_handle_info");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.submit_task_handle_info model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into submit_task_handle_info(");
            strSql.Append("CASE_SERIAL,AREA_CODE,CASE_ID,TASK_ID,TASK_PARENTID,TASK_OUNAME,TASK_USERNAME,TASK_CONTENT,TASK_ASSIGNTIME,TASK_SIGNTIME,TASK_FINISHTIME,TASK_FINISHTIME_BF,TASK_ISBACK,TASK_ISALLOT,TASK_HANDLE_LENGTH,CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@CASE_SERIAL,@AREA_CODE,@CASE_ID,@TASK_ID,@TASK_PARENTID,@TASK_OUNAME,@TASK_USERNAME,@TASK_CONTENT,@TASK_ASSIGNTIME,@TASK_SIGNTIME,@TASK_FINISHTIME,@TASK_FINISHTIME_BF,@TASK_ISBACK,@TASK_ISALLOT,@TASK_HANDLE_LENGTH,@CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,50),
                    new SqlParameter("@AREA_CODE", SqlDbType.NVarChar,20),
                    new SqlParameter("@CASE_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_PARENTID", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_OUNAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_USERNAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_CONTENT", SqlDbType.NVarChar,-1),
                    new SqlParameter("@TASK_ASSIGNTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_SIGNTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_FINISHTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_FINISHTIME_BF", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_ISBACK", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_ISALLOT", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_HANDLE_LENGTH", SqlDbType.Int,4),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.CASE_SERIAL;
            parameters[1].Value = model.AREA_CODE;
            parameters[2].Value = model.CASE_ID;
            parameters[3].Value = model.TASK_ID;
            parameters[4].Value = model.TASK_PARENTID;
            parameters[5].Value = model.TASK_OUNAME;
            parameters[6].Value = model.TASK_USERNAME;
            parameters[7].Value = model.TASK_CONTENT;
            parameters[8].Value = model.TASK_ASSIGNTIME;
            parameters[9].Value = model.TASK_SIGNTIME;
            parameters[10].Value = model.TASK_FINISHTIME;
            parameters[11].Value = model.TASK_FINISHTIME_BF;
            parameters[12].Value = model.TASK_ISBACK;
            parameters[13].Value = model.TASK_ISALLOT;
            parameters[14].Value = model.TASK_HANDLE_LENGTH;
            parameters[15].Value = model.CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.submit_task_handle_info model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update submit_task_handle_info set ");
            strSql.Append("CASE_SERIAL=@CASE_SERIAL,");
            strSql.Append("AREA_CODE=@AREA_CODE,");
            strSql.Append("CASE_ID=@CASE_ID,");
            strSql.Append("TASK_ID=@TASK_ID,");
            strSql.Append("TASK_PARENTID=@TASK_PARENTID,");
            strSql.Append("TASK_OUNAME=@TASK_OUNAME,");
            strSql.Append("TASK_USERNAME=@TASK_USERNAME,");
            strSql.Append("TASK_CONTENT=@TASK_CONTENT,");
            strSql.Append("TASK_ASSIGNTIME=@TASK_ASSIGNTIME,");
            strSql.Append("TASK_SIGNTIME=@TASK_SIGNTIME,");
            strSql.Append("TASK_FINISHTIME=@TASK_FINISHTIME,");
            strSql.Append("TASK_FINISHTIME_BF=@TASK_FINISHTIME_BF,");
            strSql.Append("TASK_ISBACK=@TASK_ISBACK,");
            strSql.Append("TASK_ISALLOT=@TASK_ISALLOT,");
            strSql.Append("TASK_HANDLE_LENGTH=@TASK_HANDLE_LENGTH,");
            strSql.Append("CreateTime=@CreateTime");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,50),
                    new SqlParameter("@AREA_CODE", SqlDbType.NVarChar,20),
                    new SqlParameter("@CASE_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_PARENTID", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_OUNAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_USERNAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_CONTENT", SqlDbType.NVarChar,-1),
                    new SqlParameter("@TASK_ASSIGNTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_SIGNTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_FINISHTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_FINISHTIME_BF", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_ISBACK", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_ISALLOT", SqlDbType.NVarChar,50),
                    new SqlParameter("@TASK_HANDLE_LENGTH", SqlDbType.Int,4),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.CASE_SERIAL;
            parameters[1].Value = model.AREA_CODE;
            parameters[2].Value = model.CASE_ID;
            parameters[3].Value = model.TASK_ID;
            parameters[4].Value = model.TASK_PARENTID;
            parameters[5].Value = model.TASK_OUNAME;
            parameters[6].Value = model.TASK_USERNAME;
            parameters[7].Value = model.TASK_CONTENT;
            parameters[8].Value = model.TASK_ASSIGNTIME;
            parameters[9].Value = model.TASK_SIGNTIME;
            parameters[10].Value = model.TASK_FINISHTIME;
            parameters[11].Value = model.TASK_FINISHTIME_BF;
            parameters[12].Value = model.TASK_ISBACK;
            parameters[13].Value = model.TASK_ISALLOT;
            parameters[14].Value = model.TASK_HANDLE_LENGTH;
            parameters[15].Value = model.CreateTime;
            parameters[16].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from submit_task_handle_info ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from submit_task_handle_info ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.submit_task_handle_info GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,CASE_SERIAL,AREA_CODE,CASE_ID,TASK_ID,TASK_PARENTID,TASK_OUNAME,TASK_USERNAME,TASK_CONTENT,TASK_ASSIGNTIME,TASK_SIGNTIME,TASK_FINISHTIME,TASK_FINISHTIME_BF,TASK_ISBACK,TASK_ISALLOT,TASK_HANDLE_LENGTH,CreateTime from submit_task_handle_info ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.submit_task_handle_info model = new CallCenterApi.Model.submit_task_handle_info();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.submit_task_handle_info DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.submit_task_handle_info model = new CallCenterApi.Model.submit_task_handle_info();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["CASE_SERIAL"] != null)
                {
                    model.CASE_SERIAL = row["CASE_SERIAL"].ToString();
                }
                if (row["AREA_CODE"] != null)
                {
                    model.AREA_CODE = row["AREA_CODE"].ToString();
                }
                if (row["CASE_ID"] != null)
                {
                    model.CASE_ID = row["CASE_ID"].ToString();
                }
                if (row["TASK_ID"] != null)
                {
                    model.TASK_ID = row["TASK_ID"].ToString();
                }
                if (row["TASK_PARENTID"] != null)
                {
                    model.TASK_PARENTID = row["TASK_PARENTID"].ToString();
                }
                if (row["TASK_OUNAME"] != null)
                {
                    model.TASK_OUNAME = row["TASK_OUNAME"].ToString();
                }
                if (row["TASK_USERNAME"] != null)
                {
                    model.TASK_USERNAME = row["TASK_USERNAME"].ToString();
                }
                if (row["TASK_CONTENT"] != null)
                {
                    model.TASK_CONTENT = row["TASK_CONTENT"].ToString();
                }
                if (row["TASK_ASSIGNTIME"] != null)
                {
                    model.TASK_ASSIGNTIME = row["TASK_ASSIGNTIME"].ToString();
                }
                if (row["TASK_SIGNTIME"] != null)
                {
                    model.TASK_SIGNTIME = row["TASK_SIGNTIME"].ToString();
                }
                if (row["TASK_FINISHTIME"] != null)
                {
                    model.TASK_FINISHTIME = row["TASK_FINISHTIME"].ToString();
                }
                if (row["TASK_FINISHTIME_BF"] != null)
                {
                    model.TASK_FINISHTIME_BF = row["TASK_FINISHTIME_BF"].ToString();
                }
                if (row["TASK_ISBACK"] != null)
                {
                    model.TASK_ISBACK = row["TASK_ISBACK"].ToString();
                }
                if (row["TASK_ISALLOT"] != null)
                {
                    model.TASK_ISALLOT = row["TASK_ISALLOT"].ToString();
                }
                if (row["TASK_HANDLE_LENGTH"] != null && row["TASK_HANDLE_LENGTH"].ToString() != "")
                {
                    model.TASK_HANDLE_LENGTH = int.Parse(row["TASK_HANDLE_LENGTH"].ToString());
                }
                if (row["CreateTime"] != null && row["CreateTime"].ToString() != "")
                {
                    model.CreateTime = DateTime.Parse(row["CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,CASE_SERIAL,AREA_CODE,CASE_ID,TASK_ID,TASK_PARENTID,TASK_OUNAME,TASK_USERNAME,TASK_CONTENT,TASK_ASSIGNTIME,TASK_SIGNTIME,TASK_FINISHTIME,TASK_FINISHTIME_BF,TASK_ISBACK,TASK_ISALLOT,TASK_HANDLE_LENGTH,CreateTime ");
            strSql.Append(" FROM submit_task_handle_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,CASE_SERIAL,AREA_CODE,CASE_ID,TASK_ID,TASK_PARENTID,TASK_OUNAME,TASK_USERNAME,TASK_CONTENT,TASK_ASSIGNTIME,TASK_SIGNTIME,TASK_FINISHTIME,TASK_FINISHTIME_BF,TASK_ISBACK,TASK_ISALLOT,TASK_HANDLE_LENGTH,CreateTime ");
            strSql.Append(" FROM submit_task_handle_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM submit_task_handle_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from submit_task_handle_info T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "submit_task_handle_info";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}